<?php declare(strict_types=1);

namespace App\Controller;

use App\Entity\Topic;
use App\Repository\TopicRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * Class MainController
 * @package App\Controller
 */
class MainController extends AbstractController
{
    private TopicRepository $topicRepository;

    public function __construct(TopicRepository $topicRepository)
    {
        $this->topicRepository = $topicRepository;
    }

    /**
     * @Route(name="index", path="/", methods={"GET"})
     */
    public function index() : Response
    {
        return $this->render('index.html.twig', ['topics' => $this->topicRepository->findAllLabels()]);
    }

    /**
     * @Route(name="next_question", path="/next/{topic}", methods={"GET"})
     * @param Request $req
     * @param string $topic
     * @return Response
     */
    public function nextQuestion(Request $req, string $topic = Topic::TOPIC_ALL) : Response
    {

    }

    /**
     * @Route(name="evaluate_question", path=/eval, methods={"POST"})
     * @param Request $req
     * @return Response
     */
    public function evaluateQuestion(Request $req) : Response
    {
        /*
         * TODO: Payload: {
         *  question: <id>,
         *  answers: {
         *    <id> : <checked>
         *  }
         */
    }
}